<template>
  <!-- <div class="typeahead-container"> -->
  <div :class="typeaheadState" :disabled="disabled">
    <!-- {{ title }} -->
    <div class="typeahead-toggle" ref="toggle" @click="toggle">
      <input
        type="text"
        class="typeahead-search"
        ref="search"
        v-model="search"
        :disabled="disabled"
        @click="clearSuggestions"
        @focus="onFocus"
        @blur="onBlur"
        @keypress="resetInput"
        @keyup.13="getSuggestions"
        @keydown.esc="onEscape"
      />
      <span class="typeahead-text" ref="text">{{ displayText }}</span>
    </div>
    <div :class="setLoading" ref="loading">
      <div class="loader is-loading"></div>
    </div>
    <ul v-if="open" class="typeahead-list">
      <li
        class="typeahead-item"
        v-for="(option, index) in filteredOptions"
        :key="index"
      >
        <a
          href=""
          class="typeahead-link has-text-white"
          @mousedown.prevent="select(option)"
          :class="[selectIndex === index ? 'typeahead-active' : '']"
        >
          {{ option.address }}
        </a>
      </li>
    </ul>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  props: {
    province: {
      type: String,
      default: ''
    },
    municipality: {
      type: String,
      default: ''
    },
    barangay: {
      type: String,
      default: ''
    },
    disabled: {
      type: Boolean,
      required: true
    }
  },
  data() {
    return {
      options: [],
      open: false,
      loaded: false,
      selectIndex: -1,
      displayText: '',
      search: '',
      searchCopy: '',
      provinceCopy: '',
      municipalityCopy: '',
      barangayCopy: ''
    };
  },
  computed: {
    typeaheadState() {
      return this.open ? 'typeahead typeahead-open' : 'typeahead';
    },

    // Filter by option attribute (name, id, etc)
    filteredOptions() {
      const exp = new RegExp(this.search, 'i');

      return this.options.filter(option => {
        return exp.test(option);
      });
    },
    setLoading() {
      return 'loader-wrapper';
    }
  },
  methods: {
    clearSuggestions() {
      if (
        !(this.province.localeCompare(this.provinceCopy) === 0) ||
        !(this.municipality.localeCompare(this.municipalityCopy) === 0) ||
        !(this.barangay.localeCompare(this.barangayCopy) === 0)
      )
        this.options = [];
    },
    getSuggestions() {
      console.log(this.barangay + ' - ' + this.barangayCopy);
      console.log(this.barangay.localeCompare(this.barangayCopy));
      if (
        !(this.province.localeCompare(this.provinceCopy) === 0) ||
        !(this.municipality.localeCompare(this.municipalityCopy) === 0) ||
        !(this.barangay.localeCompare(this.barangayCopy) === 0) ||
        !(this.search.localeCompare(this.searchCopy) === 0)
      ) {
        this.options = [];
        this.searchCopy = this.search;
        this.$refs.loading.className =
          this.$refs.loading.className + ' is-active';
        this.$refs.search.blur();
        axios
          .get(
            `http://localhost:5000/api/getPlaceId?province=${this.province}&municipality=${this.municipality}&barangay=${this.barangay}&searchText=${this.searchCopy}`
          )
          .then(response => {
            this.$refs.loading.className = 'loader-wrapper';
            this.$refs.search.focus();
            this.options = response.data.sort();
            this.provinceCopy = this.province;
            this.municipalityCopy = this.municipality;
            this.barangayCopy = this.barangay;
          })
          .catch(err => {
            console.log(err);
          });
      } else this.$refs.search.focus();
    },
    select(option) {
      // this.displayText = option.address;
      this.search = option.address;
      console.log(this.search);
      this.$emit('getPlaceId', option.place_id);
      // this.$refs.search.blur();
    },
    resetInput() {
      this.displayText = '';
    },

    toggle(e) {
      this.$refs.search.focus();
    },
    // If focused, show list
    onFocus() {
      this.open = true;
    },

    // If blurred, don't show list
    onBlur() {
      this.search = '';
      this.open = false;
    },

    onEscape() {
      this.$refs.search.blur();
    }
  }
};
</script>

<style lang="scss" scoped>
.typeahead {
  position: relative;
  z-index: 1;
  width: 100%;
  font-size: 14px;
  border-radius: 3px;

  &.typeahead-open {
    background: rgba(10, 34, 67, 0.6);
  }
  &.typeahead-open .typeahead-text {
    color: #999;
    opacity: 0.4;
  }
}

.typeahead-toggle {
  position: relative;
  z-index: 1;
  width: 100%;

  .typeahead-search {
    position: absolute;
    top: 0;
    left: 0;
    line-height: 1em;
    font-size: 1em;
    color: white;
    padding: 10px;
    width: 100%;
    max-height: 36px;
    display: block;
    cursor: text;
    background: transparent;
    border-radius: 3px;
    border: 1px solid white;
    outline: none;
    z-index: 2;
    &:disabled {
      cursor: not-allowed;
      pointer-events: all !important;
      border: 1px solid #999;
    }
  }
  .typeahead-text {
    min-height: 36px;
    font-size: 1em;
    line-height: 1em;
    padding: 10px;
    display: inline-block;
    position: relative;
    z-index: 3;
  }
}

.typeahead-list {
  margin: 0;
  padding: 0;
  max-height: 175px;
  overflow-y: scroll;

  .typeahead-item {
    display: block;

    :hover {
      background: rgb(175, 25, 88);
      color: #fff;
    }

    .typeahead-link {
      display: block;
      padding: 10px;
      line-height: 1em;
      font-size: 1em;
      cursor: pointer;
    }
  }
}

.loader-wrapper {
  position: absolute;
  top: 0;
  left: 0;
  height: 100%;
  width: 100%;
  opacity: 0;
  z-index: -1;
  transition: opacity 0.3s;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 6px;

  &.is-active {
    opacity: 1;
    z-index: 1;
  }

  .loader {
    height: 20px;
    width: 20px;
  }
}
</style>
